.nolist
useMB = 1
if useMB
	include \masm32\MasmBasic\MasmBasic.inc	; http://www.masm32.com/board/index.php?topic=12460
else
	include \masm32\include\masm32rt.inc
endif
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000		; 1000000 would be a typical value

.data
SrcA	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos.", 0
	db 0,0
SrcN	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos.", 0

align 4
SrcAs	db "This is a 30 characters string", 0
SrcNs	db "This is a 30 characters string", 0

.data?
Dest	db 100 dup(?)

.code
start:	push 1
	call ShowCpu
	if useMB and 0	; test preservation of regs
	mov ecx, 12345
	mov edx, 54321
		push offset SrcA
		call szLen
	deb 1, "szLen", eax, ecx, edx

	mov ecx, 12345
	mov edx, 54321
		invoke crt_strlen, addr SrcA
	deb 1, "crt_strlen", eax, ecx, edx

	mov ecx, 12345
	mov edx, 54321
		void Len(offset SrcA)
	deb 1, "Len", eax, ecx, edx

	mov ecx, 12345
	mov edx, 54321
		push offset SrcA
		call StrLen
	deb 1, "StrLen", eax, ecx, edx
	endif

	print "Testing string len for a 100 character string, aligned", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcA
		call szLen
	counter_end
	print str$(eax), 9, "cycles for Masm32 len", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt_strlen, addr SrcA
	counter_end
	print str$(eax), 9, "cycles for crt_strlen", 13, 10
if useMB
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		void Len(offset SrcA)
	counter_end
	print str$(eax), 9, "cycles for MasmBasic Len", 13, 10
endif
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcA
		call StrLen
	counter_end
	print str$(eax), 9, "cycles for StrLen", 13, 10, 10

	print "Testing string len for a 100 character string, unaligned", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcN
		call szLen
	counter_end
	print str$(eax), 9, "cycles for Masm32 len", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt_strlen, addr SrcA
	counter_end
	print str$(eax), 9, "cycles for crt_strlen", 13, 10

if useMB
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		void Len(offset SrcN)
	counter_end
	print str$(eax), 9, "cycles for MasmBasic Len", 13, 10
endif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcN
		call StrLen
	counter_end
	print str$(eax), 9, "cycles for StrLen", 13, 10, 10

	print "Testing string len for a 30 character string, aligned", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcAs
		call szLen
	counter_end
	print str$(eax), 9, "cycles for Masm32 len", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt_strlen, addr SrcAs
	counter_end
	print str$(eax), 9, "cycles for crt_strlen", 13, 10
if useMB
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		void Len(offset SrcAs)
	counter_end
	print str$(eax), 9, "cycles for MasmBasic Len", 13, 10
endif
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcAs
		call StrLen
	counter_end
	print str$(eax), 9, "cycles for StrLen", 13, 10, 10

	print "Testing string len for a 30 character string, unaligned", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcNs
		call szLen
	counter_end
	print str$(eax), 9, "cycles for Masm32 len", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt_strlen, addr SrcAs
	counter_end
	print str$(eax), 9, "cycles for crt_strlen", 13, 10

if useMB
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		void Len(offset SrcNs)
	counter_end
	print str$(eax), 9, "cycles for MasmBasic Len", 13, 10
endif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset SrcNs
		call StrLen
	counter_end
	print str$(eax), 9, "cycles for StrLen", 13, 10, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit
; select the two lines and press Control X to cut
; code for printing brand string and SSE level
	push 1
	call ShowCpu	; print brand string and SSE level
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]